#! /bin/sh

# This was originally based on a one-liner from a paper by Peter Miller
# ((It now does some serious mangeling of the gcc output.))


# Here is a severe limitation. The source file must be the last argument.
eval file=\$$#
dir=`dirname $file`
gcc -M -MG $* |
    sed -e 's@ /[^ ]*@@g' -e '/^ *\\/d' \
        -e "s@\(.*\).o:@$dir/\1.o $dir/\1.d:@"
#       -e 's@.*:@@' \
#       -e 's@ [^/ ]* @ @g' \
#	-e 's@ [^/ ]*\$@@g' \
#	-e "s@ \([a-zA-Z][^/ ]*\) @ $dir\1 @g" \
#	-e "s@ \([a-zA-Z][^/ ]*\)\$@ $dir\1 @g" 


exit 0

# This bit will assume the source code is the main file of a program if
# the filename does not start with a captial letter. If so it will
# find the required .o files needed to link the program.

eval name=\$$#
if echo $name | grep '^[a-z].*.cc$' > /dev/null ; then
    headers=`gcc -M -MG $* | sed -e 's@ /[^ ]*@@g'`
    objs=""
    for h in $headers
    do
	case $h in
	    /*.h )
		;;
	    *.h )
		cc=`echo $h | sed 's/.h$/.cc/'`
		o=`echo $h | sed 's/.h$/.o/'`
		if [ -f $cc ] ; then
		    objs="$objs $o"
		fi
		;;
	esac
    done
    prg=`echo $name | sed 's/.cc$//'`
    echo "$prg : $objs"
fi
