package java.awt;

// This was written from memory. There may be severe errors.
public class Rectangle {
    public int x;
    public int y;
    public int width;
    public int height;

    public Rectangle(int x, int y, int width, int height) {
	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
    }

    public Rectangle intersection(Rectangle rect) {
	int iLeft = Math.max(x, rect.x);
	int iTop = Math.max(y, rect.y);
	int iRight = Math.min(x+width, rect.x+rect.width);
	int iBottom = Math.min(y+height, rect.y+rect.height);
	return new Rectangle(iLeft, iTop, iRight-iLeft, iBottom-iTop);
    }

    public boolean isEmpty() {
	return (width<=0) || (height<=0);
    }

    public String toString() {
	return getClass().getName() + "[x=" + x + ", y=" + y +
	    ", width=" + width + ", height=" + height + "]";
    }
}
