
#include <X11/Xlib.h>

#include <cni.h>
#include "no/rwr/x/Display.h"
#include "no/rwr/x/Screen.h"

jint no::rwr::x::Screen::getRootDepth() {
    ::Display* dpy = (::Display*) (display->display);
    ::Screen* screen = ScreenOfDisplay(dpy, screenNumber);
    return screen->root_depth;
}

jint no::rwr::x::Screen::getRootWindowXID() {
    ::Display* dpy = (::Display*) (display->display);
    ::Screen* screen = ScreenOfDisplay(dpy, screenNumber);
    return RootWindowOfScreen(screen);
}

jint no::rwr::x::Screen::getDefaultColormapXID() {
    ::Display* dpy = (::Display*) (display->display);
    ::Screen* screen = ScreenOfDisplay(dpy, screenNumber);
    return DefaultColormapOfScreen(screen);
}

gnu::gcj::RawData* no::rwr::x::Screen::getRootVisualStructure() {
    ::Display* dpy = (::Display*) (display->display);
    ::Screen* screen = ScreenOfDisplay(dpy, screenNumber);
    ::Visual* visual = DefaultVisualOfScreen(screen);
    return reinterpret_cast<gnu::gcj::RawData*>(visual);
}

